--!parent
--!encoding=utf-8

--****************************************************************************
-- @file      LSW CORE LIB: IDLESLEEP
-- @author    Valentin Schmidt
-- @version   0.3
-- @desc      Reduces "CPU-Hogging" by making projector sleep on idle
--****************************************************************************

property $

----------------------------------------
-- @constructor
----------------------------------------
on new (me)

	-- arbitrary defaults
	$[#SleepTimeForeground] = 25
	$[#SleepTimeBackground] = 50
	$[#SleepTime] = $[#SleepTimeForeground]

	me.idleTime(20) -- 50/sec

	res = $.include(me.libdir&"idle.ls")

	return me
end

----------------------------------------
-- Set the sleep times (in milliseconds)
-- @param {integer} foreground
-- @param {integer} background
-- @param {integer} [now]
----------------------------------------
on setSleepTime (me, foreground, background, now)
	if voidP(now) then now = foreground
	me.$[#SleepTimeForeground] = foreground
	me.$[#SleepTimeBackground] = background
	me.$[#SleepTime] = now
end

----------------------------------------
-- Set/get the idle handler period (in milliseconds)
-- @param {integer} [ms] - in ms, not ticks!
----------------------------------------
on idleTime (me, ms)
	if voidP(ms) then return _movie.idleHandlerPeriod * 1000 / 60
	else _movie.idleHandlerPeriod = ms * 60 / 1000
end
