--!parent
--!encoding=utf-8

property _listeners
property spriteNum

----------------------------------------
-- @constructor
----------------------------------------
on new (me) 
  me._listeners = [:]
  return me
end

----------------------------------------
-- @param {symbol} event
-- @param {instance|object} [listener=_movie]
-- @param {symbol} [handler=event]
----------------------------------------
on addListener (me, event, target, handler)
  if voidP(target) then target = _movie
  if voidP(handler) then handler = event
    
  str = "property _target"&RETURN&\
  "on "&event&" (me)"&RETURN&\
  "  return call(#"&handler&", _target, me)"&RETURN&\
  "end"
  
  m = new(#script)
  m.scripttype = #parent
  m.scripttext = str
  obj = script(m.membernum).new()
  obj._target = target
  m.erase()
  
  sprite(me.spriteNum).scriptInstanceList.add(obj)
  
  if voidP(me._listeners[event]) then me._listeners[event] = []
  me._listeners[event].add(obj)
  return obj
end

----------------------------------------
-- @alias for addListener
----------------------------------------
on connect (me, event, target, handler)
  return me.addListener (event, target, handler)
end

----------------------------------------
-- 
----------------------------------------
on removeListener (me, event, listener)
  if voidP(me._listeners[event]) then return FALSE
  if me._listeners[event].getPos(listener)=0 then return FALSE
  sprite(me.spriteNum).scriptInstanceList.deleteOne(listener)
  me._listeners[event].deleteOne(listener)
  return TRUE
end

----------------------------------------
-- 
----------------------------------------
on removeAllListeners (me, event)
  if voidP(me._listeners[event]) then return FALSE
  repeat with obj in me._listeners[event]
    sprite(me.spriteNum).scriptInstanceList.deleteOne(obj)
  end repeat
  me._listeners[event] = []
  return TRUE
end

----------------------------------------
-- @alias for removeListener
--
-- me.disconnect(signal) -> Disconnect everything connected to object's <signal>
-- me.disconnect(signal, receiver) -> Disconnect <receiver> connected to object's <signal>
-- me.disconnect(signal, receiver, method)  -> Disconnect [<receiver>, <method>] connected to object's <signal>
----------------------------------------
on disconnect (me, event, listener)
  if voidP(listener) then return me.removeAllListeners(event)
  return me.removeListener (event, listener)
end

----------------------------------------
-- 
----------------------------------------
on listeners (me, event)
  return me._listeners[event]
end

----------------------------------------
-- 
----------------------------------------
on emit (me, event)
  if voidP(me._listeners[event]) then return FALSE
  return sendSprite(me.spriteNum, event)
  --return call(event, me._listeners[event])
end

----------------------------------------
-- Adds a one time listener for the event. This listener is invoked only the next 
-- time the event is fired, after which it is removed. 
----------------------------------------
--on once (me, event, listener)
--  -- TODO
--end
