--!parent
--!encoding=utf-8

--****************************************************************************
-- @file LSW CORE LIB: VLC
-- @author Valentin Schmidt
-- @version	 0.4
-- @requires xtra("Vlc")
--****************************************************************************

property ancestor

property $

property _handler
property _target

-- constants
property EVENT

----------------------------------------
-- @constructor
----------------------------------------
on new (me, props)

	-- libs
	$.import("detacher")
	$.loadXtras(me.libdir, ["Vlc.x32"], [])
	--put xtra("Vlc").interface()
	if voidP(props) then props = [:]
	if not voidP(props["callback"]) then
		me._handler = props["callback"]
		me._target = props["target"]
		if voidP(me._target) then me._target = _movie
		props["callback"] = #_eventcallback
		props["target"] = me
	end if

	me.ancestor = xtra("Vlc").new(props)

	-- load constants
	me.loadEventConstants()

	return me
end

----------------------------------------
--
----------------------------------------
on forget (me)
	--_player.alert("FORGET")
	if ilk(me.ancestor)=#instance then
		--me.ancestor.forget()
		me.ancestor = VOID
	end if
end

----------------------------------------
-- @callback
----------------------------------------
on _eventcallback (me, evt, p1,p2,p3,p4)
	--put "_eventcallback", evt
	evt = me.EVENT.getOne(evt)
	--
	--me.$.detacher.detach(me._handler, me._target, [evt, p1,p2,p3,p4])
	$.detacher.detach(me._handler, me._target, evt)
end

----------------------------------------
--
----------------------------------------
on loadEventConstants (me)

	evt = [:]

	evt[#MediaMetaChanged] = 0
    evt[#MediaSubItemAdded] = 1
    evt[#MediaDurationChanged] = 2
    evt[#MediaParsedChanged] = 3
    evt[#MediaFreed] = 4
    evt[#MediaStateChanged] = 5
    evt[#MediaSubItemTreeAdded] = 6

	--0x100
    evt[#MediaPlayerMediaChanged] = 256
    evt[#MediaPlayerNothingSpecial] = 257
    evt[#MediaPlayerOpening] = 258
    evt[#MediaPlayerBuffering] = 259
    evt[#MediaPlayerPlaying] = 260
    evt[#MediaPlayerPaused] = 261
    evt[#MediaPlayerStopped] = 262
    evt[#MediaPlayerForward] = 263
    evt[#MediaPlayerBackward] = 264
    evt[#MediaPlayerEndReached] = 265
    evt[#MediaPlayerEncounteredError] = 266
    evt[#MediaPlayerTimeChanged] = 267
    evt[#MediaPlayerPositionChanged] = 268
    evt[#MediaPlayerSeekableChanged] = 269
    evt[#MediaPlayerPausableChanged] = 270
    evt[#MediaPlayerTitleChanged] = 271
    evt[#MediaPlayerSnapshotTaken] = 272
    evt[#MediaPlayerLengthChanged] = 273
    evt[#MediaPlayerVout] = 274
    evt[#MediaPlayerScrambledChanged] = 275
    evt[#MediaPlayerCorked] = evt[#MediaPlayerScrambledChanged] + 3 + 1
    evt[#MediaPlayerUncorked] = 280
    evt[#MediaPlayerMuted] = 281
    evt[#MediaPlayerUnmuted] = 282
    evt[#MediaPlayerAudioVolume] = 283

	--0x200
    evt[#MediaListItemAdded] = 512
    evt[#MediaListWillAddItem] = 513
    evt[#MediaListItemDeleted] = 514
    evt[#MediaListWillDeleteItem] = 515

	--0x300
    evt[#MediaListViewItemAdded] = 768
    evt[#MediaListViewWillAddItem] = 769
    evt[#MediaListViewItemDeleted] = 770
    evt[#MediaListViewWillDeleteItem] = 771

	--0x400
    evt[#MediaListPlayerPlayed] = 1024
    evt[#MediaListPlayerNextItemSet] = 1025
    evt[#MediaListPlayerStopped] = 1026

	--0x500
    evt[#MediaDiscovererStarted] = 1280
    evt[#MediaDiscovererEnded] = 1281

	--0x600
    evt[#VlmMediaAdded] = 1536
    evt[#VlmMediaRemoved] = 1537
    evt[#VlmMediaChanged] = 1538
    evt[#VlmMediaInstanceStarted] = 1539
    evt[#VlmMediaInstanceStopped] = 1540
    evt[#VlmMediaInstanceStatusInit] = 1541
    evt[#VlmMediaInstanceStatusOpening] = 1542
    evt[#VlmMediaInstanceStatusPlaying] = 1543
    evt[#VlmMediaInstanceStatusPause] = 1544
    evt[#VlmMediaInstanceStatusEnd] = 1545
    evt[#VlmMediaInstanceStatusError] = 1546

	--0x700 - CUSTOM
    evt[#MouseUp] = 1792
    evt[#MouseDown] = 1793

	--0x800 - CUSTOM
    evt[#KeyUp] = 2048
    evt[#KeyDown] = 2049
    evt[#KeyRepeat] = 2050

	me.EVENT = evt
end
