--!parent
--!encoding=utf-8

global $

property _sprites
property _playHeadMouseDown
property _playHeadX
property _videoOpen

property _cbPlayHeadMoved
property _cbStepBackwards
property _cbStepForward
property _cbPlayButtonPressed

----------------------------------------
--
----------------------------------------
on new me

	-- libs
	$.import("importer", ["bmp"])
	$.import("sprite")

	me._sprites = [:]
	me._videoOpen = FALSE

	names = ["play_btn_do","pause_btn","pause_btn_do","step_back_btn_do","step_fwd_btn_do","controller_left","controller_right"]

	rects = [:]
	rects["play_btn"] = rect(0, 240, 16, 256)

	rects["controller_left"] = rect(17, 240, 24, 256)
	rects["controller_right"] = rect(281, 240, 288, 256)
	rects["controller_bg"] = rect(24, 240, 281, 256)

	rects["playhead"] = rect(16, 241, 24, 255)

	rects["step_back_btn"] = rect(288, 240, 304, 256)
	rects["step_fwd_btn"] = rect(304, 240, 320, 256)

	-- controllerBg
	m = $.importer.load($.PATH&"resources\assets\controller_bg.bmp")
	m.regpoint = point(0,0)
	r = rects["controller_bg"]
	s = $.sprite.make(m, [#rect:r], true)
	s.addListener(#mouseDown, me, #controllerBgMouseDown)
	me._sprites[#controllerBg] = s

	-- playBtn
	m = $.importer.load($.PATH&"resources\assets\play_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["play_btn"]
	s = $.sprite.make(m, [#rect:r], true)
	s.addListener(#mouseDown, me, #playBtnMouseDown)
	s.addListener(#mouseUp, me, #playBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #playBtnMouseUp)
	me._sprites[#playBtn] = s

	repeat with n in names
		m = $.importer.load($.PATH&"resources\assets\"&n&".bmp")
		m.name = n
		m.regpoint = point(0,0)
		if not voidP(rects[n]) then
			r = rects[n]
			s = $.sprite.make(m, [#rect:r])
			me._sprites[n] = s
		end if
	end repeat

	-- stepBackBtn
	m = $.importer.load($.PATH&"resources\assets\step_back_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["step_back_btn"]
	s = $.sprite.make(m, [#rect:r], true)
	s.addListener(#mouseDown, me, #stepBackBtnMouseDown)
	s.addListener(#mouseUp, me, #stepBackBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #stepBackBtnMouseUp)
	me._sprites[#stepBackBtn] = s

	-- stepFwdBtn
	m = $.importer.load($.PATH&"resources\assets\step_fwd_btn.bmp")
	m.regpoint = point(0,0)
	r = rects["step_fwd_btn"]
	s = $.sprite.make(m, [#rect:r], true)
	s.addListener(#mouseDown, me, #stepFwdBtnMouseDown)
	s.addListener(#mouseUp, me, #stepFwdBtnMouseUp)
	s.addListener(#mouseUpOutside, me, #stepFwdBtnMouseUp)
	me._sprites[#stepFwdBtn] = s

	-- playHead
	m = $.importer.load($.PATH&"resources\assets\playhead.bmp")
	m.regpoint = point(0,0)
	r = rects["playhead"]
	s = $.sprite.make(m, [#rect:r], true)
	s.addListener(#mouseDown, me, #playHeadMouseDown)
	s.addListener(#mouseUp, me, #playHeadMouseUp)
	s.addListener(#mouseUpOutside, me, #playHeadMouseUp)
	me._sprites[#playHead] = s

	return me
end

----------------------------------------
-- register callback
----------------------------------------
on onPlayHeadMoved (me, cbPlayHeadMoved)
	me._cbPlayHeadMoved = cbPlayHeadMoved
end

----------------------------------------
-- register callback
----------------------------------------
on onStepBackwards (me, cbStepBackwards)
	me._cbStepBackwards = cbStepBackwards
end

----------------------------------------
-- register callback
----------------------------------------
on onStepForward (me, cbStepForward)
	me._cbStepForward = cbStepForward
end

----------------------------------------
-- register callback
----------------------------------------
on onPlayButtonPressed (me, cbPlayButtonPressed)
	me._cbPlayButtonPressed = cbPlayButtonPressed
end

----------------------------------------
-- update UI when window was resized
----------------------------------------
on windowResized (me)
	sr = _movie.stage.rect
	repeat with i = 1 to 7
		sprite(i).locV = sr.height - 28 - 8
	end repeat

	me._sprites[#playHead].locV = me._sprites[#playHead].locV+1
	me._sprites[#controllerBg].width = sr.width - 63
	me._sprites["controller_right"].locH = sr.width - 36 - 3

	-- step btns
	me._sprites[#stepBackBtn].locH = sr.width - 24 - 8
	me._sprites[#stepFwdBtn].locH = sr.width - 8 - 8
end

----------------------------------------
-- playHead
----------------------------------------

on playHeadMouseDown me
	if not me._videoOpen then return
	me._playHeadMouseDown = 1
	me._playHeadX = _mouse.mouseH - me._sprites[#playHead].locH
	if _movie.actorlist.getPos(me)=0 then _movie.actorlist.add(me)
end

on playHeadMouseUp me
	if not me._videoOpen then return
	me._playHeadMouseDown=0
	if not me._videoOpen then _movie.actorlist.deleteOne(me)
end

----------------------------------------
-- playBtn
----------------------------------------

on playBtnMouseDown me
	me._sprites[#playBtn].member = member(me._sprites[#playBtn].member.name & "_do")
end

on playBtnMouseUp me
	mn = me._sprites[#playBtn].member.name
	me._sprites[#playBtn].member = member(mn.char[1..mn.length-3])
	if me._videoOpen and not voidP(me._cbPlayButtonPressed) then call(me._cbPlayButtonPressed, _movie)
end

----------------------------------------
-- stepBackBtn
----------------------------------------

on stepBackBtnMouseDown me
	me._sprites[#stepBackBtn].member = member("step_back_btn_do")
end

on stepBackBtnMouseUp me
	me._sprites[#stepBackBtn].member = member("step_back_btn")
	if me._videoOpen and not voidP(me._cbStepBackwards) then call(me._cbStepBackwards, _movie)
end

----------------------------------------
-- stepFwdBtn
----------------------------------------

on stepFwdBtnMouseDown me
	me._sprites[#stepFwdBtn].member = member("step_fwd_btn_do")
end

on stepFwdBtnMouseUp me
	me._sprites[#stepFwdBtn].member = member("step_fwd_btn")
	if me._videoOpen and not voidP(me._cbStepForward) then call(me._cbStepForward, _movie)
end

----------------------------------------
-- controllerBg
----------------------------------------

on controllerBgMouseDown me
	if not me._videoOpen then return
	if voidP(me._cbPlayHeadMoved) then return
	x = _mouse.mouseH - 3
	me._sprites[#playHead].locH = x
	aMin = me._sprites[#controllerBg].left-8
	aMax = me._sprites[#controllerBg].right -- 340-12
	pos = float(x-aMin)/(aMax-aMin)
	call(me._cbPlayHeadMoved, _movie, pos)
end

----------------------------------------
-- video state changes
----------------------------------------

on videoOpened me
	me._videoOpen = TRUE
end

on videoStopped me
	me._sprites[#playBtn].member = member("play_btn")
	me.updatePlayHead(0)
end

on videoPlaying me
	me._sprites[#playBtn].member = member("pause_btn")
end

on videoPaused me
	me._sprites[#playBtn].member = member("play_btn")
end

on videoClosed me
	me._sprites[#playBtn].member = member("play_btn")
	me._sprites[#playHead].locH = me._sprites[#controllerBg].left - 8
	me._videoOpen = FALSE
	_movie.actorlist.deleteOne(me)
end

----------------------------------------
--
----------------------------------------
on updatePlayHead (me, pos)
	aMin = me._sprites[#controllerBg].left - 8
	aMax = me._sprites[#controllerBg].right -- 340-12
	me._sprites[#playHead].locH = aMin + (aMax-aMin) * pos
end

----------------------------------------
-- used for dragging playHead
----------------------------------------
on stepFrame me
	aMin = me._sprites[#controllerBg].left - 8
	aMax = me._sprites[#controllerBg].right -- 340-12
	if me._videoOpen and me._playHeadMouseDown then
		x = min(aMax, max(aMin, _mouse.mouseH - me._playHeadX))
		me._sprites[#playHead].locH = x
		pos = float(x-aMin)/(aMax-aMin)
		call(me._cbPlayHeadMoved, _movie, pos)
	end if
end
