--!parent
--!encoding=utf-8

property _data
property _mem

----------------------------------------
--
----------------------------------------
on new me
	me._data = [:]
	me._mem = new(#field)
	return me
end

----------------------------------------
--
----------------------------------------
on reset me
	me._data = [:]
end

----------------------------------------
--
----------------------------------------
on update (me)
	s = ""
	cnt = count(_data)
	repeat with i = 1 to cnt

		put "menu: "&_data.getPropAt(i)&RETURN after s
		m = _data[i]
		repeat with tItem in m
			if tItem["name"]="-" then
				put "(-|"&RETURN after s
			else
				if tItem["enabled"]=0 then put "(" after s
				if tItem["checkMark"]=1 then put "! " after s
				put tItem["name"] after s
				if string(tItem["letter"])<>"" then put "/"&tItem["letter"] after s
				put "|"&tItem["handler"]&RETURN after s
			end if
		end repeat
	end repeat

	_mem.text = s
	installMenu _mem
end

----------------------------------------
--
----------------------------------------
on addMenu (me, tMenuName)
	me._data.addProp(tMenuName, [])
end

----------------------------------------
--
----------------------------------------
on addItem (me, tMenuName, tItem, tUpdateFlag)
	if voidP(tItem["enabled"]) then tItem["enabled"]=1
	if voidP(tItem["checkMark"]) then tItem["checkMark"]=0
	me._data[tMenuName].add(tItem)
	if tUpdateFlag then me.update()
end

----------------------------------------
--
----------------------------------------
on addSep (me, tMenuName)
	me.addItem(tMenuName, ["name": "-"])
end

----------------------------------------
--
----------------------------------------
on setItemEnabled (me, tMenu, tItemName, flag)
	cnt = _data[tMenu].count
	repeat with i = 1 to cnt
		if _data[tMenu][i]["name"]=tItemName then
			_data[tMenu][i]["enabled"]=flag
			_menuBar.menu[tMenu].item[i].enabled = flag
			exit repeat
		end if
	end repeat
end

----------------------------------------
--
----------------------------------------
on setItemCheckMark (me, tMenu, tItemName, flag)
	cnt = _data[tMenu].count
	repeat with i = 1 to cnt
		if _data[tMenu][i]["name"]=tItemName then
			_data[tMenu][i]["checkMark"]=flag
			_menuBar.menu[tMenu].item[i].checkMark = flag
			exit repeat
		end if
	end repeat
end
